<template>
  <div>
    <div class="titleBox">
      <div class="title">系统版本管理</div>
      <div class="btnBox">
        <el-button type="primary" @click="addVersion">
          <el-icon><CirclePlus /></el-icon>
          <span>新增</span>
        </el-button>
      </div>
    </div>
    <div class="searchBox" ref="searchBox">
      <el-form :model="listQuery" :inline="true">
        <el-form-item label="版本号">
          <el-input
            placeholder="请输入版本"
            v-model="listQuery.sysVersion"
            clearable
          ></el-input>
        </el-form-item>
        <el-form-item label="发布时间">
          <el-date-picker
            v-model="listQuery.startPublishTime"
            type="datetime"
            placeholder="选择发布时间"
            format="YYYY/MM/DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
          />
        </el-form-item>
        <el-form-item label>
          <el-date-picker
            v-model="listQuery.endPublishTime"
            type="datetime"
            placeholder="结束时间"
            format="YYYY/MM/DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
          />
        </el-form-item>

        <el-form-item>
          <el-button @click="handleFilter">查询</el-button>
          <el-button @click="reset()"> 重置 </el-button>
        </el-form-item>
      </el-form>
    </div>
    <div class="tabBox">
      <el-table
        :data="tableData"
        border
        style="width: 100%"
        :height="tableHeight"
        :key="keyCount"
      >

        <el-table-column
          sortable
          prop="sysVersion"
          label="版本"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          sortable
          prop="addFunction"
          label="新增功能"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          sortable
          prop="fixBug"
          label="修复bug"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column sortable prop="xtCjsj" label="发布时间" width="160">
          <template #default="{ row }">{{
            $filters.dateFilter(row.xtCjsj)
          }}</template>
        </el-table-column>
        <el-table-column
          sortable
          prop="bz"
          label="备注"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column label="操作" fixed="right" width="260">
          <template #default="{ row }">
            <el-button @click="updateVersion(row)" size="small">修改</el-button>
            <el-popconfirm
              confirm-button-text="是"
              cancel-button-text="否"
              icon-color="red"
              title="确定要删除?"
              @confirm="delVersion(row)"
            >
              <template #reference>
                <el-button type="danger" size="small">删除</el-button>
              </template>
            </el-popconfirm>
          </template>
        </el-table-column>
      </el-table>
      <div class="fenye" :style="{ top: tableHeight + 'px' }">
        <el-pagination
          class="pagination"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"
          :current-page="listQuery.page"
          :page-sizes="[10, 20, 50, 100]"
          :page-size="listQuery.size"
          layout="total, sizes, prev, pager, next, jumper"
          :total="total"
        ></el-pagination>
      </div>
    </div>
    <div v-if="dialogFormVisible" class="dialog">
      <div class="head_box">
        <span class="title">{{ isEdit ? "修改" : "新增" }}</span>
        <div>
          <!-- 修改 -->
          <el-button
            v-if="isEdit"
            type="primary"
            size="small"
            @click="onSave"
            :loading="buttonLoading"
            >保存</el-button
          >
          <!-- 新增 -->
          <el-button
            v-else
            type="primary"
            size="small"
            @click="onAdd"
            :loading="buttonLoading"
            >保存</el-button
          >
          <el-button size="small" @click="closeDialog">关闭</el-button>
        </div>
      </div>
      <el-form
        class="mosty-from-wrap"
        :inline="true"
        label-position="top"
        :model="dialogForm"
        ref="elform"
      >
        <el-form-item
          prop="sysVersion"
          class="one"
          label="版本"
          :rules="[{ required: true, message: '请填写版本号' }]"
          label-width="140px"
        >
          <el-input
            v-model="dialogForm.sysVersion"
            show-word-limit
            maxlength="50"
            autocomplete="off"
          ></el-input>
        </el-form-item>
        <el-form-item
          class="one"
          prop="addFunction"
          label="新增功能"
          :rules="[{ required: true, message: '请填写新增功能描述' }]"
          label-width="140px"
        >
          <el-input
            v-model="dialogForm.addFunction"
            show-word-limit
            maxlength="200"
            :autosize="{ minRows: 2, maxRows: 4 }"
            type="textarea"
          ></el-input>
        </el-form-item>
        <el-form-item
          class="one"
          prop="fixBug"
          label="修复bug"
          :rules="[{ required: true, message: '请填写修复bug' }]"
          label-width="140px"
        >
          <el-input
            v-model="dialogForm.fixBug"
            show-word-limit
            maxlength="200"
            :autosize="{ minRows: 2, maxRows: 4 }"
            type="textarea"
          ></el-input>
        </el-form-item>
        <el-form-item
          class="one"
          prop="publishTime"
          label="发布时间"
          :rules="[{ required: true, message: '请选择发布时间' }]"
          label-width="140px"
        >
          <el-date-picker
            v-model="dialogForm.publishTime"
            type="datetime"
            placeholder="选择时间"
            format="YYYY-MM-DD HH:mm:ss"
            value-format="YYYY-MM-DD HH:mm:ss"
          />
        </el-form-item>
        <el-form-item class="one" label="备注" label-width="140px">
          <el-input
            v-model="dialogForm.bz"
            :autosize="{ minRows: 2, maxRows: 4 }"
            show-word-limit
            maxlength="200"
            type="textarea"
          ></el-input>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script setup>
import { ElMessage } from "element-plus";
import { ref, reactive, onMounted,onUnmounted,getCurrentInstance } from "vue";
import {
  getSysVersionList,
  updateVersionManage,
  deleteVersionManage,
  addVersionManage
} from "@/api/user-manage";
const { proxy } = getCurrentInstance();
const keyCount = ref(0); //tabel组件刷新值
const searchBox = ref(null); // 搜索盒子
const tableHeight = ref(); // 表格高度
//查询参数
const total = ref(0);
const elform = ref(null);
const page = ref(1);
const size = ref(20);
const currentRow = ref({});
const listQuery = ref({
  page: 1,
  size: 20,
  dictName: "",
  dictCode: "",
  xtZxbz: ""
});
const isEdit = ref(true);
const dialogForm = ref({});
const buttonLoading = ref(false);
// 数据相关
const tableData = ref([]);
const dialogFormVisible = ref(false);
const formLabelWidth = "140px";
// 获取数据的方法
const getListData = async () => {
  const params = listQuery.value;
  params.current = params.page;
  const res = await getSysVersionList(params);
  tableData.value = res?.records;
  total.value = Number(res.total);
};

const handleFilter = () => {
  listQuery.value.page = 1;
  getListData();
};
getListData();

// 分页相关
/**
 * size 改变触发
 */
const handleSizeChange = (currentSize) => {
  listQuery.value.size = currentSize;
  getListData();
};
const reset = () => {
  listQuery.value = {
    page: 1,
    size: 20,
    sysVersion: "",
    startPublishTime: "",
    endPublishTime: ""
  };
  getListData();
};
/**
 * 页码改变触发
 */
const handleCurrentChange = (currentPage) => {
  listQuery.value.page = currentPage;
  getListData();
};

const updateVersion = (row) => {
  isEdit.value = true;
  dialogForm.value = { ...row };
  dialogFormVisible.value = true;
};

const addVersion = (row) => {
  isEdit.value = false;
  dialogForm.value = {};
  dialogFormVisible.value = true;
};
const onSave = () => {
  elform.value.validate((valid) => {
    if (!valid) {
      ElMessage.error("请完成必填项！");
      return false;
    }
    buttonLoading.value = true;
    updateVersionManage({
      ...dialogForm.value
    })
      .then((res) => {
        dialogFormVisible.value = false;
        ElMessage.success("修改成功");
        handleFilter();
      })
      .finally(() => {
        buttonLoading.value = false;
      });
  });
};

const onAdd = () => {
  elform.value.validate((valid) => {
    if (!valid) {
      ElMessage.error("请完成必填项！");
      return false;
    }
    buttonLoading.value = true;
    addVersionManage({
      ...dialogForm.value
    })
      .then((res) => {
        dialogFormVisible.value = false;
        ElMessage.success("新增成功");
        handleFilter();
      })
      .finally(() => {
        buttonLoading.value = false;
      });
  });
};

const delVersion = (row) => {
  deleteVersionManage({
    id: Number(row.id)
  }).then((res) => {
    ElMessage.success("删除成功");
    handleFilter();
  });
};

const closeDialog = () => {
  dialogForm.value = {};
  dialogFormVisible.value = false;
};
// 表格高度计算
const tabHeightFn = () => {
  tableHeight.value = window.innerHeight - searchBox.value.offsetHeight - 240;
};
onMounted(() => {
  tabHeightFn();
  window.onresize = function () {
    tabHeightFn();
  };
  proxy.mittBus.on("mittFn", (data) => {
    keyCount.value = data;
  });
});
onUnmounted(() => {
  proxy.mittBus.off("mittFn");
});
</script>

<style lang="scss" scoped>
@import "~@/assets/css/layout.scss";
@import "~@/assets/css/element-plus.scss";
.user-manage-container {
  .table-header-wrap {
    margin-bottom: 22px;
  }

  ::v-deep .avatar {
    width: 60px;
    height: 60px;
    border-radius: 50%;
  }

  ::v-deep .el-tag {
    margin-right: 6px;
  }

  .pagination {
    margin-top: 20px;
  }
}
</style>
